#include <stdio.h>
#include "nezfile.h"

#define SIZE_OF_BUFFER 60
#define SAMPLE_RATE 44100
#define UNIT_RENDER (((SAMPLE_RATE*SIZE_OF_BUFFER)/1000)*4)

KbNEZFile::KbNEZFile(void)
{
	hNSF = 0;
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
KbNEZFile::~KbNEZFile(void)
{
    Close();
}
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
BOOL __fastcall KbNEZFile::Open(const char *cszFileName, SOUNDINFO *pInfo)
{
	unsigned size;
	void *pbuf;

	if (!pInfo) return FALSE;

	size = NEZ_extract((char *)cszFileName, &pbuf);
	if (!size) return FALSE;
	hNSF = NSFSDK_Load (pbuf, size);
	free(pbuf);
	if (!hNSF) return FALSE;

	NSFSDK_SetFrequency (hNSF, 44100);
	NSFSDK_SetChannel (hNSF, 2);
	NSFSDK_SetNosefartFilter (hNSF, 2);
	NSFSDK_Reset (hNSF);
	NSFSDK_Volume (hNSF, 0);	/* 0 ő */

	pInfo->dwSamplesPerSec = 44100;
	pInfo->dwChannels = 2;
	pInfo->dwBitsPerSample = 16;
	pInfo->dwSeekable = 1;
	pInfo->dwUnitRender = UNIT_RENDER;
	pInfo->dwReserved1 = 1;
	pInfo->dwReserved2 = 1;
	pInfo->dwLength = NSFSDK_GetSongMax (hNSF) * 1000;

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
void __fastcall KbNEZFile::Close(void)
{
	if (hNSF)
	{
		NSFSDK_Terminate (hNSF);
		hNSF = 0;
	}
}
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
DWORD __fastcall KbNEZFile::SetPosition(DWORD dwPos)
{
	if (dwPos) NSFSDK_SetSongNo (hNSF, dwPos / 1000);
	NSFSDK_Reset (hNSF);
    return dwPos;
}
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
DWORD __fastcall KbNEZFile::Render(BYTE *Buffer, DWORD dwSize)
{
//dwSize  UNIT_RENDER ̔{łȂ΂ȂȂ
    int c = dwSize/UNIT_RENDER;
    int i;

	for(i = 0; i < c; i++){
		NSFSDK_Render (hNSF, &Buffer[i * c], UNIT_RENDER / 4);
	}

    return i * UNIT_RENDER;
}
